*Chapter 11 commands

log using chap11, text replace
use chap11-els2002, clear

*Deleting missing values and grand-mean centering sclimate
drop if missing(Profmath, stlang, public, sclimate)
tab Profmath
summarize stlang public sclimate 
generate csclimat = sclimate -r(mean)
*sum csclimat

*Unconditional model (Model 1)
meologit Profmath || SCH_ID: , 
meologit, or
estimates store null

*Random-intercept model (Model 2)
meologit Profmath stlang || SCH_ID:  
meologit, or
estimates store ranint

*Log likelihood ratio test comparing the unconditional model and random-intercept model
lrtest null ranint

*Random-coefficient model (Model 3)
meologit Profmath stlang || SCH_ID: stlang, cov(uns) 
meologit, or
estimates store ranslop1

*Contextual model with level 1 and level 2 variables (Model 4)
meologit Profmath stlang public csclimat || SCH_ID: stlang, cov(uns) 
meologit, or
estimates store ranslop2

*Log likelihood ratio test
lrtest ranint ranslop1

*Log likelihood ratio test
lrtest ranslop1 ranslop2

*Creating cross-level interactions
generate pub_lang= public*stlang
generate cli_lang=csclimat*stlang

*Contextual model with cross-level interactions (Model 5)
meologit Profmath stlang public csclimat pub_lang cli_lang || SCH_ID: stlang, cov(uns) 
meologit, or
estimates store ranslop3
lrtest ranslop2 ranslop3

*Model comparisons using AIC and BIC statistics
estimates stats null ranint ranslop1 ranslop2 ranslop3

*margins and marginsplot in Stata 13
quietly meologit Profmath i.stlang i.public csclimat || SCH_ID: stlang, cov(uns)
margins public, atmeans predict(fixedonly outcome(1)) vsquish
margins public, atmeans predict(fixedonly outcome(4)) vsquish
marginsplot

*magins and marginsplot in Stata 14
quietly meologit Profmath i.stlang i.public csclimat || SCH_ID: stlang, cov(uns)
margins public, atmeans vsquish
marginsplot

*Fitting a Multilevel PO model using meglm
meglm Profmath stlang public csclimat || SCH_ID: stlang, family(ordinal) link(logit) cov(uns)

*Fitting a Multilevel PO model using gllamm
generate cons=1
eq inter: cons
eq slope: stlang
gllamm Profmath stlang public csclimat, i(SCH_ID) nrf(2) eqs( inter slope) link(ologit) adapt
gllamm, eform

* Making publication-quality tables using outreg2
quietly meologit Profmath || SCH_ID:  
outreg2 using chap11out, e(ll chi2) dec(3) long word replace
quietly meologit Profmath stlang || SCH_ID:  
outreg2 using chap11out, e(ll chi2)  dec(3) long word append
quietly meologit Profmath stlang || SCH_ID: stlang, cov(uns) 
outreg2 using chap11out, e(ll chi2)  dec(3) long word append
quietly meologit Profmath stlang public csclimat || SCH_ID: stlang, cov(uns) 
outreg2 using chap11out, e(ll chi2)  dec(3) long word append
